#include "acctcl.h"

/******************************************************************************
Initialization procedure
******************************************************************************/

int Int64_Cmd    (ClientData, Tcl_Interp *, int, char * []) ;
int Ipfilter_Cmd (ClientData, Tcl_Interp *, int, char * []) ;
int Traffic_Cmd  (ClientData, Tcl_Interp *, int, char * []) ;
int Sepdigit_Cmd  (ClientData, Tcl_Interp *, int, char * []) ;

int Acc_Init (Tcl_Interp *interp)
{
    Tcl_CreateCommand (interp, "int64", Int64_Cmd,
		(ClientData) NULL, (Tcl_CmdDeleteProc *) NULL) ;
    Tcl_CreateCommand (interp, "ipfilter", Ipfilter_Cmd,
		(ClientData) NULL, (Tcl_CmdDeleteProc *) NULL) ;
    Tcl_CreateCommand (interp, "traffic", Traffic_Cmd,
		(ClientData) NULL, (Tcl_CmdDeleteProc *) NULL) ;
    Tcl_CreateCommand (interp, "sepdigit", Sepdigit_Cmd,
		(ClientData) NULL, (Tcl_CmdDeleteProc *) NULL) ;

    return TCL_OK ;
}


/******************************************************************************
Driver procedure
******************************************************************************/

int callproc (optable op [], int nop, ClientData clientdata,
				Tcl_Interp *interp, int argc, char *argv [])
{
    int i, r ;

    if (argc < 2)
    {
	char tmp [200] ;

	sprintf (tmp, "wrong # args: should be %s option ?arg arg ...?", argv [0]) ;
	Tcl_SetResult (interp, tmp, TCL_VOLATILE) ;
	return TCL_ERROR ;
    }

    for (i = 0 ; i < nop ; i++)
    {
	if (strcmp (argv [1], op [i].command) == 0)
	{
	    r = (*op [i].procedure) (clientdata, interp, argc, argv) ;
	    break ;
	}
    }

    if (i >= nop)			/* not found */
    {
	char tmp [200] ;

	sprintf (tmp, "bad option \"%s\": should be ", argv [1]) ;
	for (i = 0 ; i < nop ; i++)
	{
	    if (i != 0)
		strcat (tmp, ", ") ;
	    strcat (tmp, op [i].command) ;
	}
	Tcl_SetResult (interp, tmp, TCL_VOLATILE) ;
	r = TCL_ERROR ;
    }

    return r ;
}
