#include "acctcl.h"

int Sepdigit_Cmd (ClientData cd, Tcl_Interp *interp, int argc, char *argv [])
{
    char *sepgroup, *sepfloat ;
    int lengroup, lenfloat ;
    int len, newlen ;
    char *str, *newstr ;
    char *dot ;
    int i ;
    char *newp ;

    switch (argc)
    {
	case 2 :
	    sepgroup = "," ;
	    sepfloat = "." ;
	    break ;
	case 4 :
	    sepgroup = argv [2] ;
	    sepfloat = argv [3] ;
	    break ;
	default :
	    interp->result = "wrong # args: should be sepdigit fmt group float" ;
	    return TCL_ERROR ;
    }

    str = argv [1] ;			/* string to convert */

    /*
     * Estimate length of the converted string :
     * At the maximum, there is one sepgroup for each group of 3 digits,
     * and a sepfloat.
     */

    len = strlen (str) ;
    lengroup = strlen (sepgroup) ;
    lenfloat = strlen (sepfloat) ;
    newlen = len + ((len / 3) * lengroup) + lenfloat ;
    newstr = (char *) malloc (newlen + 1) ;
    if (newstr == NULL)
    {
	interp->result = "not enough memory" ;
	return TCL_ERROR ;
    }

    /*
     * Look for a dot. If not found, this is integer value.
     * Points "dot" to the end of the integral part (if any).
     */

    dot = strchr (str, '.') ;
    if (dot == NULL)
	dot = str + strlen (str) ;

    newp = newstr ;
    for (i = 0 ; i < dot - str ; i++)
    {
	if (i > 0 && (dot - str - i) % 3 == 0 && i < dot - str)
	{
	    strcpy (newp, sepgroup) ;
	    newp += lengroup ;
	}
	*newp++ = str [i] ;
    }

    if (*dot != '\0')
    {
	strcpy (newp, sepfloat) ;
	newp += lenfloat ;
	dot++ ;
    }

    while (*dot != '\0')
	*newp++ = *dot++ ;

    *newp = '\0' ;

    Tcl_SetResult (interp, newstr, TCL_DYNAMIC) ;
    return TCL_OK ;
}
