'\"
'\" Copyright (c) 1993-1994 The Regents of the University of California.
'\" Copyright (c) 1994-1996 Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) catch.n 1.6 96/03/25 20:11:08
'\" 
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  If an argument is present, then a line break is
'\"	forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" SCCS: @(#) man.macros 1.8 96/02/15 20:02:24
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$1"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH traffic n "" Tcl "Router Accounting Package"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
traffic \- Accumulates traffic information between pairs of IP addresses
.SH SYNOPSIS
\fBtraffic\fB create \fIname\fR ?\fIhashsize\fR?
.sp
\fIname\fB add \fIaddr1 addr2 nbytes\fR
.sp
\fIname\fB get \fIaddr1 addr2\fR
.sp
\fIname\fB pairs \fR?\fIlimit\fR?
.sp
\fIname\fB sort \fR?\fIlimit\fR?
.sp
\fIname\fB sortip \fR?\fIlimit\fR?
.sp
\fIname\fB total\fR
.sp
\fIname\fB stats\fR
.sp
\fIname\fB delete\fR
.BE

.SH DESCRIPTION
.PP
The \fBtraffic\fR command is used to create a table to accumulate
the number of bytes (using 64 bits arithmetic) between pairs
of IP addresses.
.PP
The \fBcreate\fR command creates a new object (which should not be
the name of an already existing procedure).
The new object is empty.
This new object can be used with the \fBadd\fR, \fBget\fR,
\fBpairs\fR, \fBsort\fR, \fBtotal\fR and
\fBdelete\fR subcommands.
.br
This object can be later deleted, with the \fBdelete\fR subcommand.
.br
Information in a traffic object is stored as a hash table.
The optional parameter \fIhashsize\fR may be used to change its
default size, which can improve speed if many pairs are added.
This value should be a prime number.
.PP
Once created, traffic information can be accumulated with the \fBadd\fR
subcommand. It takes two IP addresses, and a number of bytes (using
64 bits arithmetic, see \fBint64(n)\fR), and adds \fInbytes\fR from
\fIaddr1\fR to \fIaddr2\fR.
.PP
The \fBget\fR subcommand returns the accumulated traffic between
the two addresses, as a 3-elements list (first element: total
number of bytes exchanged, second element: number of
bytes from \fIaddr1\fR to \fIaddr2\fR, third element: number of 
bytes from \fIaddr2\fR to \fIaddr1\fR), or as an empty list if there
is no traffic information for these two addresses.
.br
Beware: all these numbers are 64 bits numbers in decimal. These
values may be too large for Tcl commands which require integer
parameters.
.PP
The \fBpairs\fR subcommand returns the list of all pairs of IP
addresses in the object. Each pair is a 2-elements list.
There is no particular ordering between the pairs, nor
inside a
pair: if \fBadd\fR has been given \fIa1\fR and \fIa2\fR,
\fBpairs\fR may returns the list {\fIa2 a1\fR} as well
as {\fIa1 a2\fR}.
.br
The number of pairs returned by \fBpairs\fR may be limited to
a fixed number with the \fIlimit\fR argument.
.PP
The \fBsort\fR subcommand returns the list of all pairs of IP
addresses in the object, sorted by accumulated traffic in
descending order. As with \fBpairs\fR, there is no particular
ordering inside a pair, and the number of returned pairs may
be limited using the \fIlimit\fR argument.
.PP
The \fBsortip\fR subcommand is identical to the \fBsort\fR
subcommand, except that the sort key is the IP address (the
largest IP address in each pair) itself.
.PP
The \fBtotal\fR subcommmand returns the total number of bytes
accumulated in the object, i.e. the total number of bytes for
all pairs in the object. The returned number is a 64 bits number
in decimal, which may be too large for Tcl commands which require
an integer.
.PP
The \fBstats\fR subcommmand gives information about the efficiency
of the internal representation of pairs. As such, it must be
interpreted with a good knowledge of the internal representation.
This subcommand returns a 4 elements list.  These elements are:
.IP
size of the table:
the optional argument given to the \fBcreate\fR command,
or the default value if none was specified
.IP
number of pairs:
total number of pairs registered in the object
.IP
hash table efficiency:
computed as the number of used hashtable entries divided by
the total number of hashtable entries. The ideal value is 100%.
If this number is near 0%, it shows that the hash value is
too large and memory is not used
.IP
hash function efficiency:
computed as the average hash list length. This number is always
greater than 1. It should be as low as possible: large values
mean slow access to the information

.SH EXAMPLE
.PP
This example creates a traffic object and accumulates 50 bytes
from 10.0.0.1 to 10.0.0.2, 30 bytes from 10.0.0.3 to 10.0.0.1
and 20 bytes more from 10.0.0.1 to 10.0.0.2.
.PP
.CS
% \fBtraffic create x\fR
% \fBx stats\fR
1789 0 0 0
% \fBx add 10.0.0.1 10.0.0.2 50\fR
% \fBx add 10.0.0.3 10.0.0.1 30\fR
% \fBx add 10.0.0.1 10.0.0.2 20\fR
% \fBx pairs\fR
{10.0.0.2 10.0.0.1} {10.0.0.3 10.0.0.1} 
% \fBx pairs 1\fR
{10.0.0.2 10.0.0.1}
% \fBx sort\fR
{10.0.0.2 10.0.0.1} {10.0.0.3 10.0.0.1} 
% \fBx get 10.0.0.2 10.0.0.1\fR
70 0 70
% \fBx stats\fR
1789 2 0.111794 1
% \fBx delete\fR
.CE

.SH KEYWORDS
IP address, traffic, sort, 64 bits arithmetic, hashing

.SH AUTHOR
Pierre David (pda@prism.uvsq.fr)
